<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<%@ page import="java.util.concurrent.ConcurrentHashMap" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="com.accesscommerce.cart.runtime.view.CartRuntimeConstants" %>
<%@ page import="com.accesscommerce.cart.gui.model.Thema" %>
<%@ page import="com.accesscommerce.cart.gui.model.NavigationPolicy" %>
<%@ page import="com.accesscommerce.cart.gui.model.StatusType" %>
<%@ page import="com.accesscommerce.cart.gui.model.Page" %>
<%@ page import="com.accesscommerce.cart.gui.model.GenericBox" %>
<%@ page import="com.accesscommerce.cart.gui.model.SpreadSheetBox" %>
<%@ page import="com.accesscommerce.cart.gui.model.ProposalBox" %>
<%@ page import="com.accesscommerce.cart.gui.model.ApprovalBox" %>
<%@ page import="com.accesscommerce.cart.gui.model.HeaderStepBox" %>
<%@ page import="com.accesscommerce.cart.gui.model.ActionBox" %>
<%@ page import="com.accesscommerce.cart.gui.model.ProcessBar" %>
<%@ page import="com.accesscommerce.cart.gui.model.Organization" %>
<%@ page import="com.accesscommerce.cart.gui.model.Translations" %>
<%@ page import="com.accesscommerce.cart.gui.model.Layout" %>
<%@ page import="com.accesscommerce.cart.gui.enums.BoxType" %>
<%@ page import="com.accesscommerce.cart.CartController" %>
<%@ page import="com.accesscommerce.cart.gui.model.HeaderBox" %>
<%@ page import="com.accesscommerce.cart.gui.model.CombinedBox" %>
<%@ page import="com.accesscommerce.cart.gui.model.LogoBox" %>
<%@ page import="com.accesscommerce.cart.gui.enums.ActionType" %>
<%@ page import="com.accesscommerce.cart.util.GuiUtils" %>
<%@ page import="com.accesscommerce.cart.model.enums.LineType" %>

<%@ taglib uri="/tags/struts-bean" prefix="bean" %>
<%@ taglib uri="/tags/struts-html" prefix="html" %>
<%@ taglib uri="/tags/struts-logic" prefix="logic" %>
<%@ taglib uri="/tags/cart" prefix="cart" %>
<%@ taglib uri="http://jawr.net/tags" prefix="jwr" %>
<%@ page language="java" pageEncoding="utf8" contentType="text/html; charset=UTF8"%>
<jsp:useBean id="viewProps" scope="session" class="com.accesscommerce.cart.runtime.view.ViewProps" />
<bean:define id="actionName" name="viewProps" property="action" type="String" />
<html>
<head>
    <meta http-equiv="pragma" content="no-cache"/>
    <meta http-equiv="cache-control" content="no-cache"/>
    <meta http-equiv="expires" content="0"/>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <title>Cameleon CPQ</title>
    <jwr:script src="/js/browserCheck.js" />
	<jwr:script src="/js/mouseEvent.js" />   
   	<jwr:script src="/js/effectsSpreadsheet.js" />
   	<jwr:script src="/js/calendar.js" />
	<jwr:script src="/js/dragAndSizing.js" />
	<jwr:script src="/js/prototype.js" />
	<jwr:script src="/js/rico.js" />
	<jwr:script src="/js/dialog.js" />
	<jwr:script src="/js/cartHeader.js" />
	<jwr:script src="/js/cartSpreadsheet.js" />
	<jwr:script src="/js/cartwindows.js" />
	<jwr:script src="/js/common.js" />
	<jwr:script src="/js/popups.js" />
	<jwr:script src="/js/updateQueue.js" />
	<jwr:script src="/js/CcmSimplePanel.js" />
	<jwr:script src="/js/window.js" />
	<jwr:script src="/js/wysiwyg.js" />


	
 		<link rel="stylesheet" type="text/css" href="<%= com.accesscommerce.cart.CartSettings.getInstance().getProperty("cartCodeBase",request.getContextPath()) %>/Theme/<bean:write name="cartView" property="theme"/>/cartSpreadsheet.css" >
 		<link rel="stylesheet" type="text/css" href="<%= com.accesscommerce.cart.CartSettings.getInstance().getProperty("cartCodeBase",request.getContextPath()) %>/Theme/<bean:write name="cartView" property="theme"/>/cartHeader.css" >
        <link rel="stylesheet" type="text/css" href="<%= com.accesscommerce.cart.CartSettings.getInstance().getProperty("cartCodeBase",request.getContextPath()) %>/Theme/<bean:write name="cartView" property="theme"/>/cartwindow.css" >
		<link rel="stylesheet" type="text/css" href="<%= com.accesscommerce.cart.CartSettings.getInstance().getProperty("cartCodeBase",request.getContextPath()) %>/Theme/<bean:write name="cartView" property="theme"/>/commonCSS.css" >
		<bean:define id="cartView" name="<%= com.accesscommerce.cart.runtime.view.CartRuntimeConstants.CART_VIEW %>" scope="session" type="com.accesscommerce.cart.CartView" />
		<%
		int lineSelectedBarCount = 1;
		final Thema thema = (Thema)request.getSession().getAttribute(CartRuntimeConstants.LAYOUT_THEMA_CPQ_UI);
		if (thema != null)
		{
			StringBuffer display = new StringBuffer();
			CartController controller = (CartController) request.getSession().getAttribute(CartRuntimeConstants.CART_CONTROLLER);
			NavigationPolicy navigationPolicy = thema.getSettings().getNavigationPolicy();
			Organization organization = thema.getOrganization();
			ConcurrentHashMap status = navigationPolicy.getStatusTypes();
			StatusType currentStatu = (StatusType)status.get(controller.getCurrentCartData().getStatus());
			ConcurrentHashMap pages = thema.getOrganization().getPages();
			String language = GuiUtils.getLanguage(controller);
			String pageName = GuiUtils.getPageName(request,navigationPolicy,cartView,controller);			
			Page currentPage = (Page)pages.get(pageName);
			ArrayList cssFiles = currentPage.getMainPart().getCssFileNamesExist(cartView);
			Layout layout = thema.getLayout();
			boolean layoutExist = layout != null && layout.getLocalizedLayouts() != null && layout.getLocalizedLayouts().get(language) != null
				&& layout.getLocalizedLayouts().get(language).getCssFiles() != null;
			for (Iterator iteratorCssFiles = cssFiles.iterator(); iteratorCssFiles.hasNext();) 
			{
				String cssFile = (String) iteratorCssFiles.next() + ".css";
				if (layoutExist && cssFile != null && layout.getLocalizedLayouts().get(language).getCssFiles().get(cssFile) != null)
				{
					cssFile = layout.getLocalizedLayouts().get(language).getCssFiles().get(cssFile).getFile();
				}
				%>
				<link rel="stylesheet" type="text/css" href="<%= com.accesscommerce.cart.CartSettings.getInstance().getProperty("cartCodeBase",request.getContextPath()) %>/Theme/<bean:write name="cartView" property="theme"/>/<%= cssFile %>">
				<%
			}
			cssFiles = organization.getCssFileNamesExist(cartView);			
			for (Iterator iteratorCssFiles2 = cssFiles.iterator(); iteratorCssFiles2.hasNext();) 
			{
				String cssFile = (String) iteratorCssFiles2.next();
				%>
				<link rel="stylesheet" type="text/css" href="<%= com.accesscommerce.cart.CartSettings.getInstance().getProperty("cartCodeBase",request.getContextPath()) %>/Theme/<bean:write name="cartView" property="theme"/>/<%= cssFile %>" >
				<%
			}
			ArrayList boxes = currentPage.getMainPart().getBoxes();
		%>
 
    <style type="text/css">
        
    <bean:write name="cartView" scope="session" property="css"  filter="false"/>
    .infoWindow_progress{
   	 background: transparent url('Theme/<bean:write name="cartView" property="theme" />/img/progress.gif') no-repeat center center
    }
    </style>
    
</head>
	
	<%	
	boolean isAlreadyOpenHeaderPart = false;
	boolean elementsInHeader = false;
	if (currentPage.getHeader()!=null && currentPage.getHeader().getBox()!=null && currentPage.getHeader().getMode().equalsIgnoreCase("on"))
	{
		%>		
		<%= currentPage.getHeader().getBox().getHTMLCode(currentPage,controller,thema) %>
		<%
	}
	%>
	<body class="mainBGWorkflow">
	<%
	GenericBox box = null;
	for (Iterator iterator = boxes.iterator(); iterator.hasNext();) 
	{
		box = (GenericBox) iterator.next();
		if (box.getType().equals(BoxType.CombinedBox))
		{
			ArrayList boxesOfCombinedBox = box.getBoxes();
			GenericBox insideCombinedBox = null;
			if (!isAlreadyOpenHeaderPart)
			{					
					isAlreadyOpenHeaderPart = true;
					%>
					<%= ((CombinedBox)box).getBeginHTMLBox(currentPage,true,controller) %>
					<%
			}
			for (Iterator iterator2 = boxesOfCombinedBox.iterator(); iterator2.hasNext();) 
			{
				insideCombinedBox = (GenericBox) iterator2.next();
				if (insideCombinedBox.getType().equals(BoxType.SpreadSheetBox))
				{
					if(elementsInHeader)
					{
					%>
					<%= insideCombinedBox.getBeginHTMLBox(currentPage) %>
					<%
					}
					%>
					<%@ include file='sample/cartApp.jsp' %>					
					<%
					if(elementsInHeader)
					{
					%>
					<%= insideCombinedBox.getEndHTMLBox(currentPage) %>
					<%
					}
					%>
					<%= box.getEndHTMLBox(currentPage) %>
					<%
				}		
				else if (insideCombinedBox.getType().equals(BoxType.ProposalBox))
				{
					if(elementsInHeader)
					{
					%>
					<%= insideCombinedBox.getBeginHTMLBox(currentPage) %>
					<%
					}
					%>
					<%@ include file='report/CustomizeDocGenForProposalBox.jsp' %>					
					<%
					if(elementsInHeader)
					{
					%>
					<%= insideCombinedBox.getEndHTMLBox(currentPage) %>
					<%
					}
					%>
					<%= box.getEndHTMLBox(currentPage) %>
					<%			
				}			
				else if(insideCombinedBox.getType().equals(BoxType.ApprovalBox))
				{
					%>
					<%= insideCombinedBox.getBeginHTMLBox(currentPage) %>
					<jsp:include page="common/approvalBox.jsp" />
					<%= insideCombinedBox.getEndHTMLBox(currentPage) %>
					<%= box.getEndHTMLBox(currentPage) %>
					<%	
				}
				else if(insideCombinedBox.getType().equals(BoxType.HeaderStepBox))
				{
					%>
					<%= insideCombinedBox.getBeginHTMLBox(currentPage) %>
					<jsp:include page="header/cartHeaderStep.jsp" />
					<%= insideCombinedBox.getEndHTMLBox(currentPage) %>
					<%= box.getEndHTMLBox(currentPage) %>
					<%	
				}	
				else if (insideCombinedBox.getType().equals(BoxType.CombinedBox))
				{
					ArrayList boxesOfInsideCombinedBox = insideCombinedBox.getBoxes();
					GenericBox insideInsideCombinedBox = null;					
					for (Iterator iterator3 = boxesOfInsideCombinedBox.iterator(); iterator3.hasNext();) 
					{
						insideInsideCombinedBox = (GenericBox) iterator3.next();
						if (insideInsideCombinedBox.getType().equals(BoxType.ProcessBar))
						{
							elementsInHeader = true;
							%>
							<%= ((ProcessBar)insideInsideCombinedBox).getMainHTMLBox(controller,currentPage,navigationPolicy,thema) %>							
							<%
						}
						else if (insideInsideCombinedBox.getType().equals(BoxType.ActionBox))
						{
							elementsInHeader = true;
							%>
							<%= ((ActionBox)insideInsideCombinedBox).getMainHTMLBox(controller,currentPage,thema) %>
							<%
						}
						else if (insideInsideCombinedBox.getType().equals(BoxType.HeaderBox))
						{
							elementsInHeader = true;
							%>							
							<%= ((HeaderBox)insideInsideCombinedBox).getMainHTMLBox(controller,currentPage,thema) %>
							<%
						}
						else
						{
							%>
							<%= insideInsideCombinedBox.getHTMLCode(currentPage,controller,thema) %>
							<%	
						}
					}																
				}				
				else if(insideCombinedBox.getType().equals(BoxType.ActionBox))
				{
					%>
					<%= ((ActionBox)insideCombinedBox).getMainHTMLBox(controller,currentPage,thema) %>
					<%				
				}
				else
				{
					%>
					<%= insideCombinedBox.getHTMLCode(currentPage,controller,thema) %>
					<%
				}
			}	
		}				
		else
		{
			%>
			<%= box.getHTMLCode(currentPage,controller,thema) %>
			<%
		}
	}
	if (currentPage.getFooter()!=null && currentPage.getFooter().getBox()!=null && currentPage.getFooter().getMode().equalsIgnoreCase("on"))
	{
		%>
		<%= currentPage.getFooter().getBox().getHTMLCode(currentPage,controller,thema) %>
		<%
	}	
	String messageAfterDisplay = (String)request.getSession().getAttribute(CartRuntimeConstants.MESSAGE_AFTER_DISPLAY);	
	String messageTypeAfterDisplay = (String)request.getSession().getAttribute(CartRuntimeConstants.MESSAGE_TYPE_AFTER_DISPLAY);
	if(controller.getLastMessage() != null && !controller.getLastMessage().equals(""))
	{
		messageAfterDisplay = controller.getLastMessage();
		messageTypeAfterDisplay = "Information";
	}
	if(controller.getLastError() != null && !controller.getLastError().equals(""))
	{
		messageAfterDisplay = controller.getLastError();
		messageTypeAfterDisplay = "Error";
	}
	if (messageAfterDisplay != null && !messageAfterDisplay.equals("") && messageTypeAfterDisplay != null  && messageTypeAfterDisplay.equals("Information"))
	{				
		%>
		<script type="text/javascript">
		ajaxEngine.registerRequest( 'popupInformationButton', 'ajaxUpdate.do' );	
		ajaxEngine.registerAjaxObject( 'updateInfo', new UpdateInfo() );
		ajaxEngine.registerAjaxElement( 'error_window' );	
		ajaxEngine.sendRequest( 'popupInformationButton', {method:"post",parameters:"messageAfterDisplay="+encodeURIComponent('<%=com.accesscommerce.cart.util.StringUtils.escapeSingleQuotes(messageAfterDisplay)%>')+"&messageTypeAfterDisplay="+'<%=messageTypeAfterDisplay%>'});	
		</script>
		<%				
		messageAfterDisplay = null;
		request.getSession().setAttribute(CartRuntimeConstants.MESSAGE_AFTER_DISPLAY,messageAfterDisplay);
	}
	else if (messageAfterDisplay != null && !messageAfterDisplay.equals("") && messageTypeAfterDisplay != null  && messageTypeAfterDisplay.equals("Error"))
	{				
		%>
		<script type="text/javascript">
		ajaxEngine.registerRequest( 'popupErrorButton', 'ajaxUpdate.do' );	
		ajaxEngine.registerAjaxObject( 'updateInfo', new UpdateInfo() );
		ajaxEngine.registerAjaxElement( 'error_window' );	
		ajaxEngine.sendRequest( 'popupErrorButton', {method:"post",parameters:"messageAfterDisplay="+encodeURIComponent('<%=com.accesscommerce.cart.util.StringUtils.escapeSingleQuotes(messageAfterDisplay)%>')+"&messageTypeAfterDisplay="+'<%=messageTypeAfterDisplay%>'});	
		</script>
		<%				
		messageAfterDisplay = null;
		request.getSession().setAttribute(CartRuntimeConstants.MESSAGE_AFTER_DISPLAY,messageAfterDisplay);
	}
}		
%>
<%@ include file="../spreadsheet/maintenanceMessagePopup.inc" %>
<%@ include file="../spreadsheet/errorPopup.inc" %>
</body>
</html>
